LINE   ;LINE DRAWING ROUTINE FOR 16K LEVEL II ON VIDEO
 ;SCREEN PRINT ROUTINE IS FOR BASE II PRINTER
 ;BOB BOOTHE 8-12-80
 	ORG	16804-1		;LINE LOCATION
 	JP	LINE		; AUTOMATICALLY ENABLE
 	ORG	16801-1
 	JP	SAVE
 	ORG	16765-1
 	JP	FIELD
 	ORG	16795-1
 	JP	RSET
 	ORG	32330		;SO END IS 7FFFH
 STARTX	DEFW	0      ;RESERVE 2 BYTES FOR EACH VARIABLE
 STARTY	DEFW	0
 ENDX	DEFW	0
 ENDY	DEFW	0
 DIRX	DEFW	0
 DIRY	DEFW	0
 LINE	EXX			; SAVE REGISTERS
 	LD	HL,(ENDX)	;GET END OF LINE
 	LD	DE,(STARTX)	;GET START
 	LD	L,H		;PUT MSB'S INTO LSB'S
 	LD	H,0		;MAKE MSB'S 0
 	LD	E,D
 	LD	D,0
 	OR	A		;RESET CARRY FLAG
 	SBC	HL,DE		;COMPUTE DIRECTION
 	LD	(DIRX),HL	;SAVE DIRECTION
 	LD	HL,(ENDY)	;REPEAT FOR Y DIRECTION
 	LD	DE,(STARTY)
 	LD	L,H
 	LD	H,0
 	LD	E,D
 	LD	D,0
 	OR	A
 	SBC	HL,DE
 	LD	(DIRY),HL
 	LD	HL,(DIRX)	;OPTIMIZE DIRECTIONS
 	LD	DE,(DIRY)
 	LD	A,L		;STORE BIT 7'S
 	AND	80H
 	LD	B,A
 	LD	A,E
 	AND	80H
 	LD	C,A
 SHIFT	SLA	L		;SHIFT UNTIL 7'S CHANGE
 	SLA	E
 	LD	A,L
 	AND	80H
 	CP	B
 	JR	NZ,DSHIFT	;IF NOT SAME DONE SHIFT
 	LD	A,E
 	AND	80H
 	CP	C
 	JR	NZ,DSHIFT
 	JR	SHIFT		;SHIFT 'EM AGAIN
 DSHIFT	LD	(DIRX),HL	;SAVE THE NEW DIRECTIONS
 	LD	(DIRY),DE
 NXTBLO	CALL	SET		;SET THE BLOCK
 	XOR	A
 	LD	HL,(ENDX)	;DOES START = END  YET
 	LD	DE,(STARTX)
 	SBC	HL,DE
 	JR	Z,MAYBE
 NOTYET	LD	HL,(STARTX)	;ADD DIRECTION TO START
 	LD	DE,(DIRX)
 	ADD	HL,DE
 	LD	(STARTX),HL
 	LD	HL,(STARTY)
 	LD	DE,(DIRY)
 	ADD	HL,DE
 	LD	(STARTY),HL
 	JR	NXTBLO
 MAYBE	OR	A		;RESET CARRY FLAG
 	LD	HL,(ENDY)	;LINE COULD BE VERTICAL
 	LD	DE,(STARTY)
 	SBC	HL,DE
 	JR	NZ,NOTYET
 	EXX			;RETURN WITH OLD REG'S
 	RET
 SET	LD	A,(STARTX+1)	;SET PIXEL (A,B)
 	LD	BC,(STARTY)	;GET A AND B FROM MSB'S
 	LD	E,0		
 	BIT	0,A		;IS A ODD
 	CALL	NZ,ADDOFF	;BIT WILL BE ODD
 	SRL	A		;DIVIDE BY 2
 	LD	L,A		;MAKE CHARACTER POSITION
 	LD	H,0		;IN HL = 0 TO 64
 	LD	A,B		;WORK ON Y DIRECTION
 	PUSH	DE		;SAVE E
 	LD	DE,64		;64 CHARACTERS PER LINE
 	OR	A		;RESET CARRY FLAG
 	SBC	HL,DE		;SUBTRACT ONE LINE
 	ADD	A,3		;ADD ONE LINE SO A>3
 BIT	SUB	3		;DIVIDE BY 3
 	ADD	HL,DE		;ADD A LINE EACH TIME
 	CP	3		;IS A<3 YET
 	JR	NC,BIT		;IF NO, KEEP SUBTRACTING
 	POP	DE		;GET OLD PART OF BIT
 	SLA	A		;DOUBLE REMAINDER
 	ADD	A,E		;ADD OLD REMAINDER
 	LD	DE,15360	;START OF VIDEO
 	ADD	HL,DE		;COMPUTE ADDRESS
 	LD	B,A		;PUT BYTE IN B
 	INC	B		;SO NOT 0
 	LD	DE,TABLE-1
 FINDT	INC	DE		;FIND POSITION IN TABLE
 	DJNZ	FINDT
 	LD	A,(DE)
 	OR	(HL)
 	LD	(HL),A
 	RET
 TABLE	DEFB	01H		;BIT 0
 	DEFB	02H		;BIT 1
 	DEFB	04H
 	DEFB	08H
 	DEFB	10H
 	DEFB	20H
 ADDOFF	INC	E		;LET E=1 FOR ODD BIT
 	RET
 FIELD	EXX			;SAVE REGISTERS
 	LD	HL,15360	;START OF VIDEO
 	LD	DE,15361	;START + 1
 	LD	BC,1023		;NUMBER OF BYTES
 	LD	(HL),128	;GRAPHIC BLANK
 	LDIR			;COPY
 	EXX
 	RET
 RSET	EXX			;REVERSE VIDEO ROUTINE
 	LD	BC,1024		;NUMBER OF BYTES
 	LD	HL,15360	;START OF VIDEO
 REVERS	LD	A,(HL)
 	XOR	3FH		;0011 1111 BINARY
 	LD	(HL),A
 	INC	HL
 	DEC	BC		;DECREMENT COUNTER
 	LD	A,B		;CHECK IF DONE
 	OR	C
 	JR	NZ,REVERS	;REPEAT TIL DONE
 	EXX
 	RET
 SAVE	EXX			;SCREEN PRINT ROUTINE
 	LD	A,27		;ESCAPE
 	CALL	PRTOUT
 	LD	A,100		;64 CHAR PER LINE
 	CALL	PRTOUT
 	LD	A,27		;ESCAPE
 	CALL	PRTOUT
 	LD	A,98		;SET VERTICAL LINE
 	CALL	PRTOUT
 	LD	A,14		;SPACING TO 14 HALF DOTS
 	CALL	PRTOUT
 	LD	HL,15360
 	LD	B,16		;NUMBER OF LINES
 LOOP	PUSH	BC
 	CALL	TRSMIT
 	CALL	DELAY
 	LD	DE,64		;CHARACTERS PER LINE
 	LD	B,64		;64 CHARACTERS PER LINE
 TOPLIN	BIT	0,(HL)		;TEST FOR BLOCK
 	CALL	SPOT
 	BIT	1,(HL)		;TEST OTHER BLOCK
 	CALL	SPOT
 	INC	HL		;MOVE ALONG
 	DJNZ	TOPLIN		;FINISH THE TOP LINE
 	OR	A		;RESET CARRY FLAG
 	SBC	HL,DE		;PUT HL BACK TO START
 	CALL	BLANKS		;FILL OUT LINE
 	CALL	TRSMIT		;REPEAT FOR OTHER BITS
 	CALL	DELAY
 	LD	B,64
 MIDLIN	BIT	2,(HL)
 	CALL	SPOT
 	BIT	3,(HL)
 	CALL	SPOT
 	INC	HL
 	DJNZ	MIDLIN
 	OR	A
 	SBC	HL,DE
 	CALL	BLANKS
 	CALL	TRSMIT
 	CALL	DELAY		;SO PRINTER CAN COOL OFF
 	LD	B,64
 BOTLIN	BIT	4,(HL)
 	CALL	SPOT
 	BIT	5,(HL)
 	CALL	SPOT
 	INC	HL
 	DJNZ	BOTLIN
 	CALL	BLANKS
 	POP	BC		;GET LINE COUNTER
 	DJNZ	LOOP		;FINISH OTHER LINES
 	EXX
 	RET
 TRSMIT	LD	A,27		;ESCAPE
 	CALL	PRTOUT
 	LD	A,99		;TRAMSMIT GRAPHICAL DATA
 	CALL	PRTOUT
 	CALL	BLANK
 	RET
 BLANKS	CALL	BLANK
 	LD	A,13		;CAUSES LINE FEED
 	CALL	PRTOUT
 	RET
 BLANK	LD	B,64		;NUMBER OF BLANKS
 	LD	A,128		;BLANK
 BLINK	CALL	PRTOUT
 	DJNZ	BLINK
 	RET
 PRTOUT	PUSH	HL		;SAVE HL
 	LD	HL,37E8H	;LP POINTER
 PRTLP8	BIT	7,(HL)		;BIT 7 ON MEANS BUSY
 	JR	NZ,PRTLP8	;THAT'S NOT MY LABEL
 	LD	(HL),A		;LP READY, SO PRINT
 	POP	HL		;GET BACK OLD HL
 	RET			;THAT WAS QUICK
 SPOT	JR	Z,NOSPOT	;Z FLAG IS PASSED
 	LD	A,7FH		;ALL 7 BITS MAKE 1 BLOCK
 TWOLIN	CALL	PRTOUT		;MAKE TWWO LINE
 	CALL	PRTOUT
 	RET
 NOSPOT	LD	A,128		;BLANK
 	JR	TWOLIN
 DELAY	LD	B,2		;NUMBER OF TIME LOOPS
 OUTLUP	PUSH	BC		;SAVE OUTSIDE COUNTER
 	LD	BC,0		;DO 65536 LOOPS
 TICTOC	DEC	BC
 	LD	A,B		;SEE IF BC IS ZERO AGAIN
 	OR	C
 	JR	NZ,TICTOC
 	POP	BC
 	DJNZ	OUTLUP
 	RET	;ADDRESS SHOULD BE 7FFFH OR LESS
 	END	1A19H		;ENTRY TO LEVEL II BASIC
